#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 505;
char s[MAXN];
int N, f[MAXN][MAXN];

int getLen(int x) {
	if (x < 10) return 1;
	if (x < 100) return 2;
	return 3;
}

void update(int l, int r, int t) {
	for (int i = l; i + t <= r; ++i)
		if (s[i] != s[i + t])
			return;
	int x = f[l][l + t - 1];
	if (t > 1) x += 2; // Parentheses needed
	x += getLen((r - l + 1) / t);
	f[l][r] = min(f[l][r], x);
}

int main() {
	int nCase = 0;
	while (scanf(" %s", s) != EOF && s[0] != '0') {
		N = strlen(s);
		for (int i = 0; i < N; ++i)
			f[i][i] = 1;
		for (int l = 2; l <= N; ++l) {
			for (int i = 0, j = l - 1; j < N; ++i, ++j) {
				f[i][j] = l;
				for (int k = i; k < j; ++k)
					f[i][j] = min(f[i][j], f[i][k] + f[k + 1][j]);
				for (int t = 1; t * t <= l; ++t) {
					if (l % t) continue;
					update(i, j, t);
					update(i, j, l / t);
				}
			}
		}
		printf("Case %d: %d\n", ++nCase, f[0][N - 1]);
	}
	return 0;
}
