#include <cstdio>
#include <cmath>

const int MAXN = 8605;
const double EPS = 1e-4, Pi = 3.14159265359;
int W, N, D, a[MAXN << 1], k;
bool b[MAXN];
double l[MAXN << 1];

double findLen(int x, int y) {
	return 2000.0 * sin(Pi * (y - x) / N);
}

bool check2(double x, int t) {
	int i = t + 1, w = 0;
	double y = 0;
	while (w < W && i < t + k) {
		if (y + l[i - 1] <= x)
			y += l[i - 1];
		else
			++w, y = 0;
		++i;
	}
	++w;
	return w <= W;
}

bool check(double x) {
	x -= 2000;
	for (int i = 1; i <= k; ++i)
		if (check2(x, i)) return true;
	return false;
}

double solve() {
	k = 0;
	for (int i = 1; i <= N; ++i)
		if (b[i])
			a[++k] = i;
	for (int i = 1; i <= k; ++i)
		a[i + k] = a[i] + N;
	for (int i = 1; i < k + k; ++i)
		l[i] = findLen(a[i], a[i + 1]);
	double l = 2000.0, r = 8300.0; // r > 2000 * pi + 2000
	while (round(l * 10) + EPS < round(r * 10)) {
		double m = (l + r) / 2;
		if (check(m)) r = m;
		else l = m;
	}
	return r;
}

int main() {
	while (scanf("%d", &W), W) {
		scanf("%d%d", &N, &D);
		for (int i = 1; i <= N; ++i)
			b[i] = false;
		for (int i = 1; i <= D; ++i) {
			int d;
			scanf("%d", &d);
			for (int j = d; j <= N; j += d)
				b[j] = true;
		}
		printf("%.1f\n", solve());
	}
	return 0;
}
