#include <cstdio>
#include <queue>
#include <utility>
using namespace std;

const int MAXX = 1005, dx[] = {-1, 0, 1, 0}, dy[] = {0, -1, 0, 1};
enum {DRY, WET, WALL};
int X, Y, T, L, W;
bool state[MAXX][MAXX];
queue<pair<pair<int, int>, int> > Q;

int sgn(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

bool ok(int x, int y, int t) {
	return x >= 1 && x <= X && y >= 1 && y <= Y && state[x][y] == DRY && t <= T;
}

int main() {
	int x, y, x2, y2, t;
	while (scanf("%d", &X), X > 0) {
		scanf("%d%d%d%d", &Y, &T, &L, &W);
		for (int i = 1; i <= X; ++i)
			for (int j = 1; j <= Y; ++j)
				state[i][j] = DRY;
		while (!Q.empty()) Q.pop();
		int ans = 0;
		for (int i = 1; i <= L; ++i)
			scanf("%d%d", &x, &y), state[x][y] = WET, ++ans, Q.push(make_pair(make_pair(x, y), 1));
		for (int i = 1; i <= W; ++i) {
			scanf("%d%d%d%d", &x, &y, &x2, &y2);
			int d1 = sgn(x2 - x), d2 = sgn(y2 - y), j = x, k = y;
			for (t = 0; ; ++t) {
				state[j][k] = WALL;
				if (j == x2 && k == y2) break;
				j += d1, k += d2;
			}
		}
		while (!Q.empty()) {
			pair<pair<int, int>, int> p = Q.front();
			Q.pop();
			x = p.first.first, y = p.first.second, t = p.second;
			for (int i = 0; i < 4; ++i) {
				x2 = x + dx[i], y2 = y + dy[i];
				if (ok(x2, y2, t + 1))
					state[x2][y2] = WET, ++ans, Q.push(make_pair(make_pair(x2, y2), t + 1));
			}
		}
		printf("%d\n", ans);
	}
	return 0;
}
